The Open Group Base Specifications Issue 6
IEEE Std 1003.1, 2004 Edition
Copyright © 2001-2004 The IEEE and The Open Group, All Rights reserved.

#### NAME

> fileno - map a stream pointer to a file descriptor

#### SYNOPSIS

> ``[CX] #include <stdio.h>
> int fileno(FILE *`stream`);``
> `
> `

#### DESCRIPTION

> The fileno() function shall return the integer file descriptor associated with the stream pointed to by stream.

#### RETURN VALUE

> Upon successful completion, fileno() shall return the integer value of the file descriptor associated with stream. Otherwise, the value -1 shall be returned and errno set to indicate the error.

#### ERRORS

> The fileno() function may fail if:

> [EBADF]
>   The stream argument is not a valid stream.

The following sections are informative.

#### EXAMPLES

> None.

#### APPLICATION USAGE

> None.

#### RATIONALE

> Without some specification of which file descriptors are associated with these streams, it is impossible for an application to set up the streams for another application it starts with fork() and exec. In particular, it would not be possible to write a portable version of the sh command interpreter (although there may be other constraints that would prevent that portability).

#### FUTURE DIRECTIONS

> None.

#### SEE ALSO

> Interaction of File Descriptors and Standard I/O Streams, fdopen(), fopen(), stdin(), the Base Definitions volume of IEEE Std 1003.1-2001, <stdio.h>

#### CHANGE HISTORY

> First released in Issue 1. Derived from Issue 1 of the SVID.

#### Issue 6

> The following new requirements on POSIX implementations derive from alignment with the Single UNIX Specification:

> - The [EBADF] optional error condition is added.

End of informative text.

UNIX ® is a registered Trademark of The Open Group.
POSIX ® is a registered Trademark of The IEEE.
[ Main Index | XBD | XCU | XSH | XRAT ]